package com.jiuqi.grid;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PropList implements Serializable {
  private List list;
  
  private Map finder;
  
  private int bufSize;
  
  private Key tmpKey;
  
  public PropList(int bufferSize) {
    this.list = new ArrayList();
    this.finder = new HashMap<Object, Object>();
    this.bufSize = bufferSize;
    this.tmpKey = new Key();
  }
  
  public byte[] get(int index) {
    return this.list.get(index);
  }
  
  public void set(int index, byte[] value) {
    this.finder.remove(this.tmpKey.setProperty(this.list.get(index)));
    byte[] b = this.list.get(index);
    System.arraycopy(value, 0, b, 0, this.bufSize);
    this.finder.put(new Key(b), new Integer(index));
  }
  
  public int indexOf(byte[] propData) {
    Integer index = (Integer)this.finder.get(this.tmpKey.setProperty(propData));
    return (index == null) ? -1 : index.intValue();
  }
  
  public int count() {
    return this.list.size();
  }
  
  public void setCount(int value) {
    int i;
    for (i = this.list.size(); i < value; i++)
      this.list.add(new byte[this.bufSize]); 
    for (i = this.list.size() - 1; i >= value; i--)
      this.list.remove(i); 
  }
  
  public int add(byte[] propData) {
    byte[] b = new byte[this.bufSize];
    System.arraycopy(propData, 0, b, 0, this.bufSize);
    int index = this.list.size();
    this.list.add(b);
    this.finder.put(new Key(b), new Integer(index));
    return index;
  }
  
  private void rebuild() {
    this.finder.clear();
    for (int i = 0; i < this.list.size(); i++)
      this.finder.put(new Key(this.list.get(i)), new Integer(i)); 
  }
  
  public void loadFromStream(Stream stream, int size) throws StreamException {
    this.list.clear();
    for (int i = 0; i < size / this.bufSize; i++) {
      byte[] b = new byte[this.bufSize];
      stream.readBuffer(b, 0, this.bufSize);
      this.list.add(b);
    } 
    rebuild();
  }
  
  public void loadFromStreamEx(Stream stream, int bufStart, int bufLen) throws StreamException {
    int count = (int)(stream.getSize() / bufLen);
    setCount(count);
    stream.setPosition(0L);
    for (int i = 0; i < count; i++) {
      byte[] buf = this.list.get(i);
      stream.readBuffer(buf, bufStart, bufLen);
    } 
    rebuild();
  }
  
  public void saveToStream(Stream stream) throws StreamException {
    for (int i = 0; i < this.list.size(); i++) {
      byte[] b = this.list.get(i);
      stream.writeBuffer(b, 0, this.bufSize);
    } 
  }
  
  public void saveToStreamEx(Stream stream, int bufStart, int bufLen) throws StreamException {
    for (int i = 0; i < this.list.size(); i++) {
      byte[] buf = this.list.get(i);
      stream.writeBuffer(buf, bufStart, bufLen);
    } 
  }
  
  public void remove(int index) {
    this.list.remove(index);
    rebuild();
  }
}
